
' - NOT REQUIRED -
' -----------------------------------------------------------------------------------------------------------------
' Microsoft Speech Platform - Software Development Kit (SDK) (Version 10.2)
' http://www.microsoft.com/downloads/en/details.aspx?FamilyID=1b1604d3-4f66-4241-9a21-90a294a5c9a4&displaylang=en
'
' Reference to: C:\Program Files\Microsoft Speech Platform SDK\Assembly\Microsoft.Speech.dll
' -----------------------------------------------------------------------------------------------------------------

' - REQUIRED -
'------------------------------------------------------------------------------------------------------------------
' Microsoft Speech Platform - Server Runtime (Version 10.2) 
' http://www.microsoft.com/downloads/en/details.aspx?FamilyID=bb0f72cb-b86b-46d1-bf06-665895a313c7&displaylang=en
'
' Languages you wish for TTS and SR, among 26 languages
' http://www.microsoft.com/downloads/en/details.aspx?FamilyID=47ffd4e5-e682-4228-8058-dd895252a3c3&displaylang=en
'
' Reference to: C:\WINDOWS\assembly\GAC_MSIL\Microsoft.Speech\10.2.0.0__31bf3856ad364e35\Microsoft.Speech.dll
'------------------------------------------------------------------------------------------------------------------

' - REQUIRED (this app requires the SR files only)
'---------------------------------------------------------------------------------------
' If you don't have the culture files installed you could get an error
' For a Culture the files to install are two, one for TTS and one for SR.
' For en-US: 'MSSpeech_TTS_en-US_Helen.msi' and 'MSSpeech_SR_en-US_TELE.msi' 
' For it-IT: 'MSSpeech_TTS_it-IT_Lucia.msi' and 'MSSpeech_SR_it-IT_TELE.msi' 
'---------------------------------------------------------------------------------------

Imports System.Windows.Forms
Imports System.Collections.Generic
Imports System.Drawing
Imports System.Media
Imports Microsoft.Speech.Recognition
Imports Microsoft.Speech.Synthesis

Partial Public Class Form1
    Inherits Form

    ' --------------------------------------------------- SR - SPEECH RECOGNITION
    Private _sre As SpeechRecognitionEngine = Nothing
    Private _strCulture As String = "en-us" ' en-us / it-it / zh-cn
    Private _recognizing As Boolean

    Private Sub Form1_Load1(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Me.Text = AppTitleAndVersion()
        ' --------------------------------- prepare the voice list
        'FillVoiceList()
        'SetVoiceIndex(0)
        ' --------------------------------- start
        Load_INI()
        ' --------------------------------- start
        'SetSelectedVoice()
        'ParseTtsLines()
        ' ---------------------------------
        ParseSrLines()
        UpdateRunStatus()
        'If Running Then SayValidWords()
        ' --------------------------------- 
        EventsAreEnabled = True
        Timer1.Start()
        Opacity = 1
        ' ------------------------------------------------- this makes SendKeys faster
        SchedulerMaxPrecision()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        StopSREngine()
        Save_INI()
        SchedulerDefaultPrecision()
    End Sub

    Private Sub Form1_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        LimitFormPosition(Me)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' ------------------------------------------------- update ProgressBar
        If _recognizing Then
            ProgressBar1.ForeColor = Color.Green
            ProgressBar1.Value = _sre.AudioLevel
            ProgressBar1.Visible = True
        Else
            'ProgressBar1.ForeColor = Color.LightGray
            'ProgressBar1.Value = 100
            ProgressBar1.Visible = False
        End If
        ' ------------------------------------------------- ExternalCommands
        DecodeExternalCommands()
    End Sub

    Private Sub ShowErrorMessage()
        Running = False
        UpdateRunStatus()
        MessageBox.Show("Please install the Speech Platform Runtime (32 or 64 bit)" + vbCrLf + _
                        "and the preferred languages TTS and SR voices", _
                        "Message from Theremino VoiceCommands", _
                        MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
        Diagnostics.Process.Start(".\Installers")
    End Sub


    ' ====================================================================
    '  BUTTONS - LOAD and SAVE
    ' ====================================================================
    Private Sub btn_RecogLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RecogLoad.Click
        SaveRecogFile()
        RecogLoad()
        ParseSrLines()
        StartSREngine()
        'SayValidWords()
    End Sub
    Private Sub btn_RecogSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RecogSave.Click
        RecogSave()
    End Sub

    ' ====================================================================
    '  BUTTONS - RUN and MICROPHONE
    ' ====================================================================
    Friend Running As Boolean = True
    Private Sub btn_Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Run.Click
        Running = Not Running
        UpdateRunStatus()
    End Sub
    Private Sub UpdateRunStatus()
        If Running Then
            btn_Run.BackColor = Color.Orange
            StartSREngine()
        Else
            btn_Run.BackColor = Color.WhiteSmoke
            StopSREngine()
        End If
    End Sub

    Private Sub btn_Microphone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Microphone.Click
        Shell("control mmsys.cpl,,1", AppWinStyle.NormalFocus)
    End Sub

    ' ====================================================================
    '  EDIT SR TEXT
    ' ====================================================================
    Private SRTextChanged As Boolean = False
    Private Sub txt_ValidWords_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles txt_ValidWords.MouseClick
        StopSREngine()
        txt_ValidWords.BackColor = Color.FromArgb(250, 250, 240)
    End Sub
    Private Sub txt_ValidWords_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_ValidWords.TextChanged
        If Not EventsAreEnabled Then Return
        SRTextChanged = True
    End Sub
    Private Sub txt_ValidWords_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_ValidWords.MouseLeave
        If Not EventsAreEnabled Then Return
        If SRTextChanged Then
            SaveRecogFile()
            ParseSrLines()
            SRTextChanged = False
            StartSREngine()
        Else
            StartSREngine()
        End If
        txt_ValidWords.BackColor = Color.FromArgb(240, 240, 240)
    End Sub

    ' ====================================================================
    '  SPEECH RECOGNITION START STOP
    ' ====================================================================
    Private Sub RecognizePause()
        If _sre IsNot Nothing Then
            _sre.RecognizeAsyncCancel()
            _sre.RecognizeAsyncStop()
            _recognizing = False
        End If
    End Sub
    Private Sub RecognizeRestart()
        If Not Running Then Return
        If _sre IsNot Nothing Then
            Try
                _sre.RecognizeAsync(RecognizeMode.Multiple)
            Catch
            End Try
            _recognizing = True
        End If
    End Sub

    Private Sub StopSREngine()
        If _sre IsNot Nothing Then
            ' ------------------------------------------ remove SpeechRecognized event handler
            RemoveHandler _sre.SpeechRecognized, _
                          AddressOf sre_SpeechRecognized
            ' ------------------------------------------
            _sre.RecognizeAsyncCancel()
            _sre.RecognizeAsyncStop()
        End If
        _recognizing = False
    End Sub

    Private Sub StartSREngine()
        If Not Running Then Return
        ' ------------------------------------------
        If _sre IsNot Nothing Then
            _sre.RecognizeAsyncCancel()
            _sre.RecognizeAsyncStop()
        End If
        ' ------------------------------------------ 
        Try
            _sre = New SpeechRecognitionEngine(New Globalization.CultureInfo(_strCulture))
        Catch
            ShowErrorMessage()
            Return
        End Try
        ' ------------------------------------------ create choices

        ' TODO - RECOGNITON PHASE 2

        Dim words As New Choices()
        For Each w As SR_Word In SR_Words
            words.Add(w.SR_text)
        Next
        words.Add(" ")
        ' ------------------------------------------ create grammar and load into SR
        Dim gb As New GrammarBuilder()
        gb.Culture = New System.Globalization.CultureInfo(_strCulture)
        gb.Append(words)
        _sre.LoadGrammar(New Grammar(gb))
        'Text = _sre.Grammars.Count.ToString
        ' ------------------------------------------ set recog props
        '_sre.MaxAlternates = 1
        '_sre.BabbleTimeout = TimeSpan.FromMilliseconds(1)
        '_sre.InitialSilenceTimeout = TimeSpan.FromMilliseconds(1)
        '_sre.EndSilenceTimeout = TimeSpan.FromMilliseconds(1)
        '_sre.EndSilenceTimeoutAmbiguous = TimeSpan.FromMilliseconds(1)
        ' ------------------------------------------ set SpeechRecognized event handler
        AddHandler _sre.SpeechRecognized, _
                      AddressOf sre_SpeechRecognized
        ' ------------------------------------------ start
        _sre.SetInputToDefaultAudioDevice()
        _sre.RecognizeAsync(RecognizeMode.Multiple)
        _recognizing = True
    End Sub

    Private Sub sre_SpeechRecognized(ByVal sender As Object, ByVal e As SpeechRecognizedEventArgs)
        DecodeRecognizedWorld(e.Result)
    End Sub


    ' ====================================================================
    '  PARSE SpeechRecognition TEXT
    ' ====================================================================
    Private Structure SR_Word
        Dim LineIndex As Int32
        Dim SR_text As String
        Dim Cmd As String
        Dim CmdParams As String
    End Structure

    Private SR_Words(-1) As SR_Word

    Private Sub ParseSrLines()
        SlotText_DecodedWords = 1
        SlotText_ExternalCommands = -1
        Confidence = 0.6
        ReDim SR_Words(-1)
        Dim l As String
        Dim lines() As String = txt_ValidWords.Text.Split(Chr(13))
        For LineIndex As Int32 = 0 To lines.Length - 1
            l = lines(LineIndex)
            l = RemoveComments(l)
            l = ReplaceMultipleSpacesAndTrim(l)
            l = l.Trim
            If l.StartsWith("-") Or l.StartsWith("'") Or l.StartsWith("//") Then Continue For
            If l <> "" Then
                Dim sa() As String = l.Split(" "c)
                If sa.Length > 0 Then
                    ' ------------------------------------------ decode commands
                    If sa(0).ToLower.StartsWith("cmd_") Then
                        Select Case sa(0).ToLower
                            Case "cmd_slotdecodedwords"
                                SlotText_DecodedWords = CInt(Val(CollectFields(sa)))
                            Case "cmd_slotexternalcommands"
                                SlotText_ExternalCommands = CInt(Val(CollectFields(sa)))
                            Case "cmd_recoglanguage"
                                _strCulture = sa(2)
                            Case "cmd_confidence"
                                Confidence = CSng(Val(CollectFields(sa)))
                            Case Else
                                MessageBox.Show("Unrecognized command """ + l + """", _
                                                "Message from Theremino VoiceCommands", _
                                                MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
                        End Select
                        Continue For
                    End If

                    ' TODO - RECOGNITON PHASE 1
                    ' ------------------------------------------ decode words
                    Dim srw As SR_Word = New SR_Word
                    srw.LineIndex = LineIndex
                    ' ------------------------------------------ Test for LOAD commands
                    Dim CmdPos As Int32 = -1
                    srw.Cmd = ""
                    For i As Int32 = 1 To sa.Length - 2
                        If sa(i).ToLower = "load" Then
                            srw.Cmd = sa(i)
                            CmdPos = i
                            For j As Int32 = i + 1 To sa.Length - 1
                                srw.CmdParams += sa(j) + " "
                            Next
                            srw.CmdParams = srw.CmdParams.Trim
                            Exit For
                        End If
                    Next
                    ' ------------------------------------------ compose the SR_text
                    If CmdPos < 0 Then CmdPos = sa.Length
                    For j As Int32 = 0 To CmdPos - 1
                        srw.SR_text += sa(j) + " "
                    Next
                    srw.SR_text = srw.SR_text.Trim
                    ' ------------------------------------------ add word to SR_Words array
                    ReDim Preserve SR_Words(SR_Words.Length)
                    SR_Words(SR_Words.Length - 1) = srw
                End If
            End If
        Next
    End Sub

    Private Function CollectFields(ByVal sa() As String) As String
        CollectFields = ""
        For i As Int32 = 1 To sa.Length - 1
            If i = 1 And sa(1) = "=" Then Continue For
            CollectFields += sa(i) + " "
        Next
        CollectFields = CollectFields.Trim
    End Function

    Private Function ReplaceMultipleSpacesAndTrim(ByVal s As String) As String
        s = s.Replace(vbTab, " ")
        s = s.Replace(vbCr, " ")
        s = s.Replace(vbLf, " ")
        While s.Contains("  ")
            s = s.Replace("  ", " ")
        End While
        Return s.Trim
    End Function


    ' ====================================================================
    '  DECODE RECOGNIZED WORD
    ' ====================================================================
    Private SlotText_DecodedWords As Int32 = 1
    Private SlotText_ExternalCommands As Int32 = -1
    Private Confidence As Single = 0.6
    Private Sub DecodeRecognizedWorld(ByVal result As Microsoft.Speech.Recognition.RecognitionResult)
        ' ------------------------------------------------------------------ show results
        'Text = Result.Homophones.Count.ToString
        'Text = Result.Words.Count.ToString
        'Text = result.Audio.Duration.ToString
        'Text = result.Confidence.ToString()

        ' TODO - RECOGNITON PHASE 3

        ' ------------------------------------------------------------------ limit by Confidence
        If result.Confidence < Confidence Then Return
        ' ------------------------------------------------------------------ decode
        Dim str As String = result.Text.ToLower
        For Each word As SR_Word In SR_Words
            If word.SR_text.ToLower = str Then
                Select Case word.Cmd.ToLower
                    Case "load"
                        LoadRecogFile(word.CmdParams)
                        Exit For
                    Case Else
                        ' -------------------------------------------------- send to SlotText
                        StringSlots.WriteString(SlotText_DecodedWords, _
                                                word.SR_text)
                End Select
                ' --------------------------------------------------- 
                TextBox_SelectLine(txt_ValidWords, word.LineIndex)
                ' ---------------------------------------------------
                Exit For
            End If
        Next
    End Sub

    Private Sub LoadRecogFile(ByVal file As String)
        If RecogFileExists(file) Then
            StopSREngine()
            SaveRecogFile()
            RecogTextFile = file
            ReadRecogFile()
            ParseSrLines()
            StartSREngine()
            'SayValidWords(word.word)
        End If
    End Sub

    ' ====================================================================
    '  DECODE EXTERNAL COMMANDS
    ' ====================================================================
    Private Sub DecodeExternalCommands()
        If SlotText_ExternalCommands > -1 Then
            Dim str As String = StringSlots.ReadString(SlotText_ExternalCommands)
            If str <> "" Then
                StringSlots.WriteString(SlotText_ExternalCommands, "")
                Select Case str.ToLower
                    Case "run"
                        If Not Running Then
                            Running = True
                            UpdateRunStatus()
                        End If
                    Case "stop"
                        If Running Then
                            Running = False
                            UpdateRunStatus()
                        End If
                    Case Else
                        If str.ToLower.StartsWith("load ") Then
                            str = str.ToLower.Replace("load ", "")
                            LoadRecogFile(str)
                        Else
                            MessageBox.Show("Unrecognized external command """ + str + """" + vbCrLf + vbCrLf + _
                                            "Valid External Commands are: RUN / STOP / LOAD FileName.txt", _
                                            "Message from Theremino VoiceCommands", _
                                            MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
                        End If
                End Select
            End If
        End If
    End Sub

End Class

